package Java6.Detyra1;

public class EkipiOlimpik {
    private String emri;
    private Sportisti[] sportistet;
    private int index = 0;

    public EkipiOlimpik(String e, int nrS) throws SportistiException{
        if(e == null || e.isEmpty()){
            throw new SportistiException("Emri i ekipit gabim!");
        }
        emri = e;
        if(nrS < 0){
            throw new SportistiException("nrS gabim!");
        }
        sportistet = new Sportisti[nrS];
    }

    public boolean ekziston(Sportisti s) throws SportistiException{
        if(s == null){
            throw new SportistiException("S == null - ekziston");
        }
        for(int i = 0; i < index; i++){
            if(s.equals(sportistet[i])){
                return true;
            }
        }
        return false;
    }

    public void shtoSportistin(Sportisti s) throws SportistiException{
        if(s == null){
            throw new SportistiException("Sportisti = NULL");
        }else if(ekziston(s)){
            throw new SportistiException(s + " ekziston!");
        }else if(index == sportistet.length){
            throw new SportistiException("Nuk ka vend per " + s);
        }else{
            sportistet[index++] = s;
        }
    }

    public void shtypDistancen(double dist) throws SportistiException{
        if(dist < 0){
            throw new SportistiException("Dist < 0 " + dist);
        }
        if(index == 0){
            throw new SportistiException("Nuk ka vrapues!");
        }


        for(int i = 0; i < index; i++){
            if(sportistet[i] instanceof Vrapuesi){
                if(((Vrapuesi)sportistet[i]).getDistanca() == dist){
                    System.out.println(sportistet[i]);
                }
            }
        }
    }

    public Atleti[] ktheAtletetMosha(int m) throws SportistiException{
        if(m < 0){
            throw new SportistiException("Mosha < 0");
        }
        if(index == 0){
            throw new SportistiException("Nuk ka atlet!");
        }

        Atleti[] atletet = null;
        int count = 0;
        for(int i = 0; i < index; i++){
            if(sportistet[i] instanceof Atleti){
                if(((Atleti)sportistet[i]).getMosha() == m){
                    count++;
                }
            }
        }

        if(count ==0){
            throw new SportistiException("Count = 0 - ktheAtletetMosha!");
        }

        atletet = new Atleti[count];
        int pozita = 0;

        for(int i = 0; i < index; i++){
            if(sportistet[i] instanceof Atleti){
                if(((Atleti)sportistet[i]).getMosha() == m){
                    atletet[pozita++] = (Atleti)sportistet[i];
                }
            }
        }

        return atletet;
    }

    public Sportisti gjiniaMeERe(char gj) throws SportistiException{

        if(gj != 'M' && gj !='F' && gj != 'A'){
            throw new SportistiException("Gjinia - gabim gjiniaMeERe!");
        }
        if(index == 0){
            throw new SportistiException("Nuk ka sportist gjiniaMeERe!");
        }


        Sportisti s = null;
        for(int i = 0; i < index; i++){
            if(s == null || (sportistet[i].getGjinia()==gj && s.getMosha()>=sportistet[i].getMosha())){
                s = sportistet[i];
            }
        }

        return s;
    }

    public void print(){
        for(int i = 0; i < index; i++){
            System.out.println(sportistet[i]);
        }
    }

    public static void main(String [] args){
        EkipiOlimpik eo = null;
        try{
            eo = new EkipiOlimpik("Kosova team", 25);
            Sportisti s1 = new Futbollisti(-1, "Futbollisti1", 18, 'F', 10);
            Sportisti s2 = new Futbollisti(2, "Futbollisti2", 19, 'M', 11);
            eo.shtoSportistin(s1);
            eo.shtoSportistin(s2);
        }catch(SportistiException se){
            System.out.println(se.getMessage());
        }
        try{
	        Sportisti s3 = new Karateisti(3, "Karateisti1", 18, 'M', "Taekwondo");
	        Sportisti s4 = new Karateisti(4, "Karateisti2", 17, 'F', "Taekwondo");
	
	        Sportisti s5 = new Vrapuesi(5, "Vrapuesi1", 17, 'F', 2, 300);
	        Sportisti s6 = new Vrapuesi(6, "Vrapuesi2", 18, 'M', 2, 400);
	        Sportisti s7 = new Vrapuesi(7, "Vrapuesi3", 18, 'M', 2, 300);
	
	        
	        eo.shtoSportistin(s3);
	        eo.shtoSportistin(s4);
	        eo.shtoSportistin(s5);
	        eo.shtoSportistin(s6);
	        eo.shtoSportistin(s7);
	
	        System.out.println("Lista e plote e sportisteve:");
	        eo.print();
	
	        System.out.println("===========================================");
	
	        System.out.println("Vrapuesit me distance 300m:");
	        eo.shtypDistancen(300);
	
	        System.out.println("===========================================");
	
	        System.out.println("Atletet e moshes 18 vjecare:");
	        for(Atleti a: eo.ktheAtletetMosha(-18)){
	            System.out.println(a);
	        }
	        
	        System.out.println("===========================================");
	
	        System.out.println("Sportistja e fundit me e re: " + eo.gjiniaMeERe('F'));
	    }catch(SportistiException se){
            System.out.println(se.getMessage());
        }finally{
            System.out.println("Fundi!!");
        }
    }
}

